Dirac Video Codec

# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::SequenceCompressor Class Reference

Compresses a sequence of frames/fields from a stream. More...

`#include <seq_compress.h>`

Inheritance diagram for dirac::SequenceCompressor:
[legend]
Collaboration diagram for dirac::SequenceCompressor:
[legend]

List of all members.

## Public Member Functions

- SequenceCompressor (StreamPicInput *pin, EncoderParams &encp, DiracByteStream &dirac_byte_stream)
    Constructor.
- virtual ~SequenceCompressor ()
    Destructor.
- virtual bool LoadNextFrame ()=0
    Load data.
- const EncPicture * CompressNextPicture ()
    Compress the next picture in sequence.
- virtual void SetPicTypeAndRefs (PictureParams &pparams)=0
    Set up the appropriate prediction parameters for a picture.
- const EncPicture * GetPictureEncoded ()
    Return a pointer to the most recent picture encoded.
- DiracByteStats EndSequence ()
- bool Finished ()
    Determine if compression is complete.
- void SignalEOS ()
    Signal end of sequence.

## Protected Member Functions

- void SetMotionParameters ()
    Set up the motion block parameters.
- virtual int CodedToDisplay (const int pnum)=0
    Uses the GOP parameters to convert picture numbers in coded order to display order.
- void MakeSequenceReport ()
    Make a report to screen on the coding results for the whole sequence.
- virtual void CleanBuffers ()
    Remove unwanted pictures from picture buffers.
- virtual void UpdateCBRModel (EncPicture &my_picture, const PictureByteIO *picture_byteio)=0
    Update the CBR model based on the data we've compressed.
- void UpdateIntraPicCBRModel (const PictureParams &, const bool is_a_cut)
    Update the parameters to be used in advance of coding an intra frame.
- bool CanEncode ()
    Returns true if the encoder can encode a picture.

## Protected Attributes

- bool m_all_done
    Completion flag, returned via the Finished method.
- bool m_just_finished
    Flag indicating whether we've just finished.
- OLBParams m_basic_olb_params0
    A class to hold the basic block parameters.
- OLBParams m_basic_olb_params1
    A class to hold the basic block parameters.
- OLBParams m_basic_olb_params2
    A class to hold the basic block parameters.
- OLBParams * m_intra_olbp
    A class to hold block parameters to use when there are lots of intra blocks.
- SourceParams & m_srcparams
    The parameters of the input source.
- EncoderParams & m_encparams
    The parameters used for encoding.
- PicturePredParams & m_predparams
    The parameters used for ME/MC.
- int m_L1_sep
    The L1 separation currently in use.
- PictureParams m_pparams
    Generic picture parameters for initialising pictures.
- StreamPicInput * m_pic_in
    Pointer pointing at the picture input.
- EncQueue m_enc_pbuffer
    A picture buffer used for local storage of pictures whilst pending re-ordering or being used for reference.
- int m_current_display_pnum
    The number of the current picture to be coded, in display order.
- int m_current_code_pnum
    The number of the current picture to be coded, in coded order.
- int m_show_pnum
    The number of the picture which should be output for concurrent display or storage.
- int m_last_picture_read
    The index, in display order, of the last picture read.
- int m_gop_start_num
    The picture number of the last GOP start.
- int m_delay
    A delay so that we don't display what we haven't coded.
- QualityMonitor m_qmonitor
    A class for monitoring the quality of pictures and adjusting parameters appropriately.
- RateController * m_ratecontrol
    A class for monitoring and controlling bit rate.
- PictureCompressor m_pcoder
    A class to hold the picture compressor object.
- DiracByteStream & m_dirac_byte_stream
    Output destination for compressed data in bitstream format.
- bool m_eos_signalled
    Flag to check if End of Sequence has been signalled by the end user.

## Private Member Functions

- SequenceCompressor (const SequenceCompressor &cpy)
    Copy constructor is private and body-less.
- SequenceCompressor & operator= (const SequenceCompressor &rhs)
    Assignment = is private and body-less.

## Detailed Description

This class compresses a sequence of frames/fields, frame by frame. or field by field. It currently uses GOP parameters set in the encoder parameters in order to define the temporal prediction structure. A version to incorporate non-GOP structures is TBC.

This is an abstract class.

## Constructor & Destructor Documentation

dirac::SequenceCompressor::SequenceCompressor | ( | StreamPicInput * | pin,
|  | EncoderParams & | encp,
|  | DiracByteStream & | dirac_byte_stream |
| ) |  |  |

Creates a sequence compressor, and prepares to begin compressing with the first picture.Sets up picture padding in the picture input if necesary

Parameters:

  | pin | an input stream containing a sequence of frames
  | encp | parameters for the encoding process
  | dirac_byte_stream | Output destination for compressed data

virtual dirac::SequenceCompressor::~SequenceCompressor | ( |  | ) | `[virtual]`

Destructor. Must delete IO objects created by constructor.

dirac::SequenceCompressor::SequenceCompressor | ( | const SequenceCompressor & | cpy | ) | `[private]`

Copy constructor is private and body-less. This class should not be copied.

## Member Function Documentation

virtual bool dirac::SequenceCompressor::LoadNextFrame | ( |  | ) | `[pure virtual]`

Load one picture of data into the Sequence Compressor. Sets m_all_done to true if no more data is available to be loaded. Input can be frame or field. So the child class will have to implement this function.

Returns:
  true - if frame load succeeded. false - otherwise

Implemented in dirac::FrameSequenceCompressor, and dirac::FieldSequenceCompressor.

const EncPicture* dirac::SequenceCompressor::CompressNextPicture | ( |  | ) |

This function codes the next picture in coding order and returns the next picture in display order. In general these will differ, and because of re-ordering there is a delay which needs to be imposed. This creates problems at the start and at the end of the sequence which must be dealt with. At the start we just keep outputting picture 0. At the end you will need to loop for longer to get all the pictures out. It's up to the calling function to do something with the decoded pictures as they come out -- write them to screen or to file, for example. . If coding is fast enough the compressed version could be watched real-time (with suitable buffering in the calling function to account for encode-time variations).

NOTE: LoadNextFrame must be called atleast once before invoking this method.

Returns:
  pointer to the next locally decoded picture available for display

virtual void dirac::SequenceCompressor::SetPicTypeAndRefs | ( | PictureParams & | pparams | ) | `[pure virtual]`

Implemented in dirac::FrameSequenceCompressor, and dirac::FieldSequenceCompressor.

const EncPicture* dirac::SequenceCompressor::GetPictureEncoded | ( |  | ) |

DiracByteStats dirac::SequenceCompressor::EndSequence | ( |  | ) |

bool dirac::SequenceCompressor::Finished | ( |  | ) | `[inline]`

Indicates whether or not the last picture in the sequence has been compressed.

Returns:
  true if last picture has been compressed; false if not

References m_all_done.

void dirac::SequenceCompressor::SignalEOS | ( |  | ) | `[inline]`

References m_eos_signalled.

void dirac::SequenceCompressor::SetMotionParameters | ( |  | ) | `[protected]`

virtual int dirac::SequenceCompressor::CodedToDisplay | ( | const int | pnum | ) | `[protected, pure virtual]`

Uses the GOP parameters to convert picture numbers in coded order to display order. Pure virtual function. The child class will have to define it.

Parameters:

  | pnum | the picture number in coded order

Implemented in dirac::FrameSequenceCompressor, and dirac::FieldSequenceCompressor.

void dirac::SequenceCompressor::MakeSequenceReport | ( |  | ) | `[protected]`

virtual void dirac::SequenceCompressor::CleanBuffers | ( |  | ) | `[protected, virtual]`

virtual void dirac::SequenceCompressor::UpdateCBRModel | ( | EncPicture & | my_picture,
|  | const PictureByteIO * | picture_byteio |
| ) |  |  | `[protected, pure virtual]`

Implemented in dirac::FrameSequenceCompressor, and dirac::FieldSequenceCompressor.

void dirac::SequenceCompressor::UpdateIntraPicCBRModel | ( | const PictureParams & | ,
|  | const bool | is_a_cut |
| ) |  |  | `[protected]`

bool dirac::SequenceCompressor::CanEncode | ( |  | ) | `[protected]`

SequenceCompressor& dirac::SequenceCompressor::operator= | ( | const SequenceCompressor & | rhs | ) | `[private]`

Assignment = is private and body-less. This class should not be assigned..

## Member Data Documentation

bool dirac::SequenceCompressor::m_all_done`[protected]`

Referenced by Finished().

bool dirac::SequenceCompressor::m_just_finished`[protected]`

Flag which is false if we've been all-done for more than one picture, true otherwise (so that we can take actions on finishing once only).

OLBParams dirac::SequenceCompressor::m_basic_olb_params0`[protected]`

OLBParams dirac::SequenceCompressor::m_basic_olb_params1`[protected]`

OLBParams dirac::SequenceCompressor::m_basic_olb_params2`[protected]`

OLBParams* dirac::SequenceCompressor::m_intra_olbp`[protected]`

SourceParams& dirac::SequenceCompressor::m_srcparams`[protected]`

EncoderParams& dirac::SequenceCompressor::m_encparams`[protected]`

PicturePredParams& dirac::SequenceCompressor::m_predparams`[protected]`

int dirac::SequenceCompressor::m_L1_sep`[protected]`

PictureParams dirac::SequenceCompressor::m_pparams`[protected]`

StreamPicInput* dirac::SequenceCompressor::m_pic_in`[protected]`

EncQueue dirac::SequenceCompressor::m_enc_pbuffer`[protected]`

int dirac::SequenceCompressor::m_current_display_pnum`[protected]`

int dirac::SequenceCompressor::m_current_code_pnum`[protected]`

int dirac::SequenceCompressor::m_show_pnum`[protected]`

int dirac::SequenceCompressor::m_last_picture_read`[protected]`

int dirac::SequenceCompressor::m_gop_start_num`[protected]`

int dirac::SequenceCompressor::m_delay`[protected]`

QualityMonitor dirac::SequenceCompressor::m_qmonitor`[protected]`

RateController* dirac::SequenceCompressor::m_ratecontrol`[protected]`

PictureCompressor dirac::SequenceCompressor::m_pcoder`[protected]`

DiracByteStream& dirac::SequenceCompressor::m_dirac_byte_stream`[protected]`

bool dirac::SequenceCompressor::m_eos_signalled`[protected]`

Referenced by SignalEOS().

The documentation for this class was generated from the following file:

- seq_compress.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.